procedure minv(infile,outfile)

# Routine to invert masks so that <=0 --> 1 and >0 --> 0
#
# 960416: added check for 0-1 range, and more careful with image extension
# 970430: changed so that all values >=1 now set to 0, with warning
# 970730: changed so that values <=0 --> 1 and values >0 --> 0
# 970930: intermediate step: copy to .imh format & real pixtype
#		to avoid .pl limitations
# 971101: modified so a fixed temporary image name is not created

string 	infile		{prompt = "Input mask image (best include .pl or .imh)"}
string 	outfile		{prompt = "Output (inverted) mask image"}

begin

	string inf,outf,inex,outex,biteme

# Get query parameters:

	fileroot(infile)
		inf = fileroot.root
		inex = "."//fileroot.extension
		if(inex==".")inex=""
	fileroot(outfile,validim+)
		outf = fileroot.root
		outex = "."//fileroot.extension
		if(outex==".")outex=""

	minmax (inf, force+, ver-)
	if ((minmax.minval < 0.) || (minmax.maxval > 1.)) {
		beep
       print("WARNING! Pixels in image range beyond 0-1.")
#      print("WARNING! Pixels in image range beyond 0-1... inversion not done.")
#		return
	}
#	if(inf//inex != outf//outex)
	biteme = mktemp("_biteme")
	imcopy(inf//inex,biteme//".imh",ver-)
	imar(biteme//".imh","+",0.,biteme//".imh",ver-,noact-,pixt="real")
	imreplace (biteme//".imh",1.,lower=0.01,upper=INDEF)
	imreplace (biteme//".imh",2.,lower=INDEF,upper=0.02)
	imarith (biteme//".imh","-",1.,biteme//".imh")
	if(inf//inex==outf//outex)imdel(inf//inex, ver-)
	imcopy(biteme//".imh",outf//outex,ver-)
	imdel(biteme//".imh",ver-)

end

